/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of GLog.xs. Do not edit this file, edit GLog.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "GLog.xs"
/*
 * Copyright (C) 2003-2005, 2009, 2012-2013 by the gtk2-perl team (see the
 * file AUTHORS for the full list)
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * $Id$
 */

#include "gperl.h"
#include "gperl-gtypes.h"
#include "gperl-private.h" /* for GPERL_SET_CONTEXT */

#if 0
  "Skipped embedded POD."
#endif
#line 41 "GLog.xs"

#if 0
/* Log level shift offset for user defined
 * log levels (0-7 are used by GLib).
 */
#define G_LOG_LEVEL_USER_SHIFT  (8)

/* GLib log levels that are considered fatal by default */
#define G_LOG_FATAL_MASK        (G_LOG_FLAG_RECURSION | G_LOG_LEVEL_ERROR)
#endif

SV *
newSVGLogLevelFlags (GLogLevelFlags flags)
{
	return gperl_convert_back_flags (GPERL_TYPE_LOG_LEVEL_FLAGS, flags);
}

GLogLevelFlags
SvGLogLevelFlags (SV * sv)
{
	return gperl_convert_flags (GPERL_TYPE_LOG_LEVEL_FLAGS, sv);
}

/* for GLogFunc style, to be invoked by gperl_log_func() below */
static GPerlCallback *
gperl_log_callback_new (SV *log_func, SV *user_data)
{
	GType param_types[3];
	param_types[0] = G_TYPE_STRING;
	param_types[1] = GPERL_TYPE_LOG_LEVEL_FLAGS;
	param_types[2] = G_TYPE_STRING;
	return gperl_callback_new (log_func, user_data,
				   3, param_types, G_TYPE_NONE);
}
static void
gperl_log_func (const gchar   *log_domain,
                GLogLevelFlags log_level,
                const gchar   *message,
                gpointer       user_data)
{
	gperl_callback_invoke ((GPerlCallback *) user_data, NULL,
	                       log_domain, log_level, message);
}

#if GLIB_CHECK_VERSION (2, 6, 0)
/* the GPerlCallback currently installed through
   g_log_set_default_handler(), or NULL if no such */
static GPerlCallback *gperl_log_default_handler_callback = NULL;
G_LOCK_DEFINE_STATIC (gperl_log_default_handler_callback);
#endif

void
gperl_log_handler (const gchar   *log_domain,
                   GLogLevelFlags log_level,
                   const gchar   *message,
                   gpointer       user_data)
{
	char * desc;

	gboolean in_recursion = (log_level & G_LOG_FLAG_RECURSION) != 0;
	gboolean is_fatal = (log_level & G_LOG_FLAG_FATAL) != 0;
	PERL_UNUSED_VAR (user_data);

	log_level &= G_LOG_LEVEL_MASK;

	if (!message)
		message = "(NULL) message";

	switch (log_level) {
		case G_LOG_LEVEL_CRITICAL: desc = "CRITICAL"; break;
		case G_LOG_LEVEL_ERROR:    desc = "ERROR";    break;
		case G_LOG_LEVEL_WARNING:  desc = "WARNING";  break;
		case G_LOG_LEVEL_MESSAGE:  desc = "Message";  break;
		default: desc = "LOG";
	}

	GPERL_SET_CONTEXT;
	warn ("%s%s%s %s**: %s",
	      (log_domain ? log_domain : ""),
	      (log_domain ? "-" : ""),
	      desc,
	      (in_recursion ? "(recursed) " : ""),
	      message);

	/* the standard log handler calls abort() for G_LOG_LEVEL_ERROR
	 * messages.  this is handy for being able to stop gdb on the
	 * error and get a backtrace.  we originally mapped the error
	 * level stuff to croak(), but this broke the ability to find
	 * these errors in gdb, and didn't stop the script as expected
	 * in the perl debugger.  so, let's preserve the GLib semantics. */
	if (is_fatal)
		/* XXX would be nice to get a perl backtrace here, but
		 * XXX Carp::cluck() doesn't print anything useful here. */
		abort ();
}

#define ALL_LOGS (G_LOG_LEVEL_MASK | G_LOG_FLAG_FATAL | G_LOG_FLAG_RECURSION)

#if 0
  "Skipped embedded POD."
#endif
#line 149 "GLog.xs"
gint
gperl_handle_logs_for (const gchar * log_domain)
{
	return g_log_set_handler (log_domain, ALL_LOGS,
	                          gperl_log_handler, NULL);
}

#if 0
  "Skipped embedded POD."
#endif
#line 159 "GLog.xs"

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 158 "GLog.c"

XS(XS_Glib__Log_set_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Log_set_handler)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::Log::set_handler", "class, log_domain, log_levels, log_func, user_data=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 198 "GLog.xs"
	GPerlCallback * callback;
#line 174 "GLog.c"
	guint	RETVAL;
	dXSTARG;
	gchar_ornull *	log_domain;
	SV *	log_levels = ST(2);
	SV *	log_func = ST(3);
	SV *	user_data;

	/* same as SvGChar(), but allows undef as NULL */
	if (gperl_sv_is_defined (ST(1))) {
		sv_utf8_upgrade (ST(1));
		log_domain = (gchar_ornull *)SvPV_nolen (ST(1));
	} else {
		log_domain = NULL;
	};

	if (items < 5)
	    user_data = NULL;
	else {
	    user_data = ST(4);
	}
#line 200 "GLog.xs"
	callback = gperl_log_callback_new (log_func, user_data);
	RETVAL = g_log_set_handler (log_domain,
				    SvGLogLevelFlags (log_levels),
				    gperl_log_func, callback);
	/* we have no choice but to leak the callback. */
	/* FIXME what about keeping a hash by the ID, and freeing it on
	 *       Glib::Log->remove_handler ($id)? */
        /*pcg: would probably take more memory in typical programs... */
#line 204 "GLog.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Glib__Log_remove_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Log_remove_handler)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::Log::remove_handler", "class, log_domain, handler_id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	gchar_ornull *	log_domain;
	guint	handler_id = (guint)SvUV(ST(2));

	/* same as SvGChar(), but allows undef as NULL */
	if (gperl_sv_is_defined (ST(1))) {
		sv_utf8_upgrade (ST(1));
		log_domain = (gchar_ornull *)SvPV_nolen (ST(1));
	} else {
		log_domain = NULL;
	};

	g_log_remove_handler(log_domain, handler_id);
    }
    XSRETURN_EMPTY;
}


XS(XS_Glib__Log_default_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Log_default_handler)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::Log::default_handler", "log_domain, log_level, message, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const gchar *	log_domain;
	SV *	log_level = ST(1);
	const gchar *	message;

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(0));
	log_domain = (const gchar *)SvPV_nolen (ST(0));

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(2));
	message = (const gchar *)SvPV_nolen (ST(2));
#line 228 "GLog.xs"
	g_log_default_handler (log_domain, SvGLogLevelFlags(log_level),
			       message, NULL);
#line 266 "GLog.c"
    }
    XSRETURN_EMPTY;
}

#if GLIB_CHECK_VERSION (2, 6, 0)
#define XSubPPtmpAAAA 1


XS(XS_Glib__Log_set_default_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Log_set_default_handler)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::Log::set_default_handler", "class, log_func, user_data=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 261 "GLog.xs"
	GLogFunc new_func = &g_log_default_handler;
	GLogFunc old_func;
	GPerlCallback *new_callback = NULL;
	GPerlCallback *old_callback;
#line 292 "GLog.c"
	SV *	RETVAL;
	SV *	log_func = ST(1);
	SV *	user_data;

	if (items < 3)
	    user_data = NULL;
	else {
	    user_data = ST(2);
	}
#line 266 "GLog.xs"
	if (gperl_sv_is_defined (log_func)) {
		/* check for log_func == \&Glib::Log::default_handler and
		 * turn that into g_log_default_handler() directly, rather
		 * than making a callback into perl and out again.  This is
		 * mainly an optimization, but if something weird has
		 * happened then the direct C function will be much more
		 * likely to work.
		 */
		HV *st;
		GV *gv;
		CV *cv = sv_2cv(log_func, &st, &gv, 0);
		if (cv && CvXSUB(cv) == XS_Glib__Log_default_handler) {
			/* new_func already initialized to
			 * g_log_default_handler above
                         */
		} else {
			new_func = gperl_log_func;
			new_callback = gperl_log_callback_new
				(log_func, user_data);
		}
	}

	G_LOCK (gperl_log_default_handler_callback);

	old_func = g_log_set_default_handler (new_func, new_callback);
	old_callback = gperl_log_default_handler_callback;
	gperl_log_default_handler_callback = new_callback;

	G_UNLOCK (gperl_log_default_handler_callback);

	RETVAL = &PL_sv_undef;
	if (old_func == g_log_default_handler) {
		CV *cv = get_cv ("Glib::Log::default_handler", 0);
		assert (cv);
		RETVAL = newRV_inc ((SV*) cv);
		SvREFCNT_inc (RETVAL);
	} else if (old_func == gperl_log_func) {
		RETVAL = old_callback->func;
		SvREFCNT_inc (RETVAL);
	}
	if (old_callback) {
		gperl_callback_destroy (old_callback);
	}
#line 346 "GLog.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif

XS(XS_Glib_log); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib_log)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::log", "class, log_domain, log_level, message");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	gchar_ornull *	log_domain;
	SV *	log_level = ST(2);
	const gchar *	message;

	/* same as SvGChar(), but allows undef as NULL */
	if (gperl_sv_is_defined (ST(1))) {
		sv_utf8_upgrade (ST(1));
		log_domain = (gchar_ornull *)SvPV_nolen (ST(1));
	} else {
		log_domain = NULL;
	};

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(3));
	message = (const gchar *)SvPV_nolen (ST(3));
#line 324 "GLog.xs"
	g_log (log_domain, SvGLogLevelFlags (log_level), "%s", message);
#line 384 "GLog.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Glib__Log_set_fatal_mask); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Log_set_fatal_mask)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::Log::set_fatal_mask", "class, log_domain, fatal_mask");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	const gchar *	log_domain;
	SV *	fatal_mask = ST(2);

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(1));
	log_domain = (const gchar *)SvPV_nolen (ST(1));
#line 330 "GLog.xs"
	RETVAL = newSVGLogLevelFlags 
		(g_log_set_fatal_mask (log_domain,
		                       SvGLogLevelFlags (fatal_mask)));
#line 413 "GLog.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Glib__Log_set_always_fatal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Log_set_always_fatal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Glib::Log::set_always_fatal", "class, fatal_mask");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	SV *	fatal_mask = ST(1);
#line 338 "GLog.xs"
	RETVAL = newSVGLogLevelFlags 
		(g_log_set_always_fatal (SvGLogLevelFlags (fatal_mask)));
#line 438 "GLog.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Glib_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "class, domain, message");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 373 "GLog.xs"
	GLogLevelFlags flags = G_LOG_LEVEL_MESSAGE;
#line 461 "GLog.c"
	gchar_ornull *	domain;
	const gchar *	message;

	/* same as SvGChar(), but allows undef as NULL */
	if (gperl_sv_is_defined (ST(1))) {
		sv_utf8_upgrade (ST(1));
		domain = (gchar_ornull *)SvPV_nolen (ST(1));
	} else {
		domain = NULL;
	};

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(2));
	message = (const gchar *)SvPV_nolen (ST(2));
#line 375 "GLog.xs"
	switch (ix) {
		case 0: flags = G_LOG_LEVEL_ERROR; break;
		case 1: flags = G_LOG_LEVEL_MESSAGE; break;
		case 2: flags = G_LOG_LEVEL_CRITICAL; break;
		case 3: flags = G_LOG_LEVEL_WARNING; break;
	}
	g_log (domain, flags, "%s", message);
#line 484 "GLog.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Glib__Log); /* prototype to pass -Wmissing-prototypes */
XS(boot_Glib__Log)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Glib::Log::set_handler", XS_Glib__Log_set_handler, file);
        newXS("Glib::Log::remove_handler", XS_Glib__Log_remove_handler, file);
        newXS("Glib::Log::default_handler", XS_Glib__Log_default_handler, file);
#if XSubPPtmpAAAA
        newXS("Glib::Log::set_default_handler", XS_Glib__Log_set_default_handler, file);
#endif
        newXS("Glib::log", XS_Glib_log, file);
        newXS("Glib::Log::set_fatal_mask", XS_Glib__Log_set_fatal_mask, file);
        newXS("Glib::Log::set_always_fatal", XS_Glib__Log_set_always_fatal, file);
        cv = newXS("Glib::error", XS_Glib_error, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Glib::critical", XS_Glib_error, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Glib::warning", XS_Glib_error, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("Glib::message", XS_Glib_error, file);
        XSANY.any_i32 = 1 ;
    }

    /* Initialisation Section */

#line 166 "GLog.xs"
	gperl_handle_logs_for (NULL);
	/* gperl_handle_logs_for ("main"); */
	gperl_handle_logs_for ("GLib");
	gperl_handle_logs_for ("GLib-GObject");
	gperl_register_fundamental (GPERL_TYPE_LOG_LEVEL_FLAGS,
	                            "Glib::LogLevelFlags");

#if XSubPPtmpAAAA
#endif
#line 540 "GLog.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

